unit uMain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, TAGraph, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ComCtrls, ButtonPanel, Menus, Spin, ExtCtrls, XMLPropStorage, Grids,
  Crt, Unix, BaseUnix, uGlobalVar, uLog, uGPIOBibliothek, uConfig, uGPIOTemperatur;

type

  { TForm1 }

  { THeizung }

  THeizung = class(TForm)
    FuehlerSpeichern: TButton;
    Chart1: TChart;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    StringGridTemperatur: TStringGrid;
    Temperatur: TGroupBox;
    HGroup: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    mEinstellung: TMenuItem;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    TemperatureEvent: TTimer;
    ZirkulationHourEvent: TTimer;
    ZirkulationMinEvent: TTimer;
    SchalterEvent: TTimer;
    TThermoschalter: TToggleBox;
    TPumpe2: TToggleBox;
    TPumpe3: TToggleBox;
    TPumpe4: TToggleBox;
    TPumpe5: TToggleBox;
    TPumpe6: TToggleBox;
    TPumpe7: TToggleBox;
    TPumpe8: TToggleBox;
    XMLPropStorage1: TXMLPropStorage;
    ZGroup: TGroupBox;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    Sommerzeit: TRadioButton;
    TZirkulationspumpe: TToggleBox;
    Winterzeit: TRadioButton;
    StatusBar1: TStatusBar;
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FuehlerSpeichernClick(Sender: TObject);
    procedure mEinstellungClick(Sender: TObject);
    procedure TemperatureEventTimer(Sender: TObject);
    procedure TPumpe2Click(Sender: TObject);
    procedure TPumpe3Click(Sender: TObject);
    procedure TPumpe4Click(Sender: TObject);
    procedure TPumpe5Click(Sender: TObject);
    procedure TPumpe6Click(Sender: TObject);
    procedure TPumpe7Click(Sender: TObject);
    procedure TPumpe8Click(Sender: TObject);
    procedure ZirkulationHourEventTimer(Sender: TObject);
    procedure ZirkulationMinEventTimer(Sender: TObject);
    procedure SchalterEventTimer(Sender: TObject);
    procedure TThermoschalterChange(Sender: TObject);
    procedure TZirkulationspumpeChange(Sender: TObject);
  private

  public

  end;

var Heizung : THeizung;


implementation

{$R *.lfm}

{ TForm1 }




// Initialisiere Pumpen/Schalter und schalte auf definierte Standardwerte

procedure THeizung.FormActivate (Sender: TObject);

begin
  Config.StringGridPumpeName.LoadFromFile ('Pumpenliste.txt');

  StringGridTemperatur.LoadFromFile ('Temperaturliste.txt');
  TemperatureEvent.Interval := Config.SpinEditTempAbfrage.Value*1000;

  TZirkulationspumpe.Caption := 'P1 '+Config.StringGridPumpeName.Cells [1,1];
  TPumpe2.Caption := 'P2 '+Config.StringGridPumpeName.Cells [1,2];
  TPumpe3.Caption := 'P3 '+Config.StringGridPumpeName.Cells [1,3];
  TPumpe4.Caption := 'P4 '+Config.StringGridPumpeName.Cells [1,4];
  TPumpe5.Caption := 'P5 '+Config.StringGridPumpeName.Cells [1,5];
  TPumpe6.Caption := 'P6 '+Config.StringGridPumpeName.Cells [1,6];
  TPumpe7.Caption := 'P7 '+Config.StringGridPumpeName.Cells [1,7];
  TPumpe8.Caption := 'P8 '+Config.StringGridPumpeName.Cells [1,8];

  StringGridTemperatur.colwidths[0] := 56;
  StringGridTemperatur.colwidths[1] := 148;
  StringGridTemperatur.colwidths[2] := 148;

  GPIOInit (PINZirkulationspumpe);
  GPIOSetForOutput (PINZirkulationspumpe);
  GPIOSwitchRelais (PINZirkulationspumpe,RelaisAus);

  GPIOInit (PINPumpe2);
  GPIOSetForOutput (PINPumpe2);
  GPIOSwitchRelais (PINPumpe2,TPumpe2.Checked);

  GPIOInit (PINPumpe3);
  GPIOSetForOutput (PINPumpe3);
  GPIOSwitchRelais (PINPumpe3,TPumpe3.Checked);

  GPIOInit (PINPumpe4);
  GPIOSetForOutput (PINPumpe4);
  GPIOSwitchRelais (PINPumpe4,TPumpe4.Checked);

  GPIOInit (PINPumpe5);
  GPIOSetForOutput (PINPumpe5);
  GPIOSwitchRelais (PINPumpe5,TPumpe5.Checked);

  GPIOInit (PINPumpe6);
  GPIOSetForOutput (PINPumpe6);
  GPIOSwitchRelais (PINPumpe6,TPumpe6.Checked);

  GPIOInit (PINPumpe7);
  GPIOSetForOutput (PINPumpe7);
  GPIOSwitchRelais (PINPumpe7,TPumpe7.Checked);

  GPIOInit (PINPumpe8);
  GPIOSetForOutput (PINPumpe8);
  GPIOSwitchRelais (PINPumpe8,TPumpe8.Checked);

  GPIOInit (PINThermoschalter);
  GPIOSetForInput (PINThermoschalter);
end;


procedure THeizung.FuehlerSpeichernClick(Sender: TObject);
begin
  StringGridTemperatur.SaveToFile ('Temperaturliste.txt');
  ShowMessage ('Zur Übernahme der Änderung bitte Programm neu starten!');
end;



procedure THeizung.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  GPIOUnexport (PINZirkulationspumpe);
  GPIOUnexport (PINPumpe2);
  GPIOUnexport (PINPumpe3);
  GPIOUnexport (PINPumpe4);
  GPIOUnexport (PINPumpe5);
  GPIOUnexport (PINPumpe6);
  GPIOUnexport (PINPumpe7);
  GPIOUnexport (PINPumpe8);
  GPIOUnexport (PINThermoschalter);
end;


procedure THeizung.mEinstellungClick(Sender: TObject);
begin
  Config.ShowModal;
end;


procedure THeizung.TThermoschalterChange(Sender: TObject);
begin
  IF TThermoschalter.Checked
     then TThermoSchalter.Color := clLime
     else TThermoSchalter.Color := clRed;
end;


procedure THeizung.TZirkulationspumpeChange(Sender: TObject);
begin
  GPIOSwitchRelais (PINZirkulationspumpe, TZirkulationspumpe.Checked);

  IF TZirkulationspumpe.Checked
     then TZirkulationspumpe.Color := clLime
     else TZirkulationspumpe.Color := clRed;

  ZTimerMin := 1;
  ZTimerHour := 1;
end;


(* Warum geht er hier vor dem FormActivate (Initialisieren der Pumpen)
   rein, sollte doch nur beim Klicken sein. Hat zwar keine Auswirkung, da ohne
   Initialisierung kein Schalten, aber unsauber.
   Anmerkung: Jede zweite Pumpe war beim Verlassen Aktiv und wird später beim
   Initialisierern wieder auf den gleichen Stand gesetzt *)

procedure THeizung.TPumpe2Click(Sender: TObject);

begin
  GPIOSwitchRelais (PINPumpe2, TPumpe2.Checked);

  IF TPumpe2.Checked
     then TPumpe2.Color := clLime
     else TPumpe2.Color := clRed;
end;


// hier geht er jedoch nach dem FormActivate rein ????

procedure THeizung.TPumpe3Click(Sender: TObject);
begin
  GPIOSwitchRelais (PINPumpe3, TPumpe3.Checked);

  IF TPumpe3.Checked
     then TPumpe3.Color := clLime
     else TPumpe3.Color := clRed;
end;

// hier wieder vor FormAktivate

procedure THeizung.TPumpe4Click(Sender: TObject);
begin
  GPIOSwitchRelais (PINPumpe4, TPumpe4.Checked);

  IF TPumpe4.Checked
     then TPumpe4.Color := clLime
     else TPumpe4.Color := clRed;
end;


// hier danach usw

procedure THeizung.TPumpe5Click(Sender: TObject);
begin
  GPIOSwitchRelais (PINPumpe5, TPumpe5.Checked);

  IF TPumpe5.Checked
     then TPumpe5.Color := clLime
     else TPumpe5.Color := clRed;
end;


procedure THeizung.TPumpe6Click(Sender: TObject);
begin
  GPIOSwitchRelais (PINPumpe6, TPumpe6.Checked);

  IF TPumpe6.Checked
     then TPumpe6.Color := clLime
     else TPumpe6.Color := clRed;
end;


procedure THeizung.TPumpe7Click(Sender: TObject);
begin
  GPIOSwitchRelais (PINPumpe7, TPumpe7.Checked);

  IF TPumpe7.Checked
     then TPumpe7.Color := clLime
     else TPumpe7.Color := clRed;
end;


procedure THeizung.TPumpe8Click(Sender: TObject);
begin
  GPIOSwitchRelais (PINPumpe8, TPumpe8.Checked);

  IF TPumpe8.Checked
     then TPumpe8.Color := clLime
     else TPumpe8.Color := clRed;
end;


procedure THeizung.ZirkulationHourEventTimer(Sender: TObject);
var LastZirkulationStart : TDateTime;

begin
  inc (ZTimerHour);

  IF not TZirkulationspumpe.Checked
         and (ZTimerHour > SpinEdit1.Value*3600)
         and (ZTimerMin = 1) then
     begin
       TZirkulationspumpe.Checked := true;
       TZirkulationspumpe.Color := clLime;
       GPIOSwitchRelais (PINZirkulationspumpe, TZirkulationspumpe.Checked);
       ZTimerMin := 1;
       LastZirkulationStart := Now;
       StatusBar1.Panels[0].Text := 'Letzer Start Zirkulationspumpe: '+FormatDateTime('hh:nn:ss',LastZirkulationStart);
     end;
end;


procedure THeizung.ZirkulationMinEventTimer(Sender: TObject);
begin
  IF TZirkulationspumpe.Checked then begin
    inc (ZTimerMin);

    IF ZTimerMin > SpinEdit2.Value*60 then begin
       TZirkulationspumpe.Checked := false;
       TZirkulationspumpe.Color := clRed;
       GPIOSwitchRelais (PINZirkulationspumpe, TZirkulationspumpe.Checked);
       ZTimerMin := 1;
       ZTimerHour := 1;
    end;
  end;
end;


procedure THeizung.SchalterEventTimer(Sender: TObject);
var SchalterStatus : boolean;

begin
  GPIOGetSchalterStatus (PINThermoschalter, SchalterStatus);
  TThermoschalter.Checked := SchalterStatus;
end;


procedure THeizung.TemperatureEventTimer(Sender: TObject);
begin
  GetTempWerte (StringGridTemperatur);
end;



end.

